#!/bin/sh

echo "# Report header files which aren't self contained."
echo "# I.e. can not be compiled by only themself."
echo "# Excluding beos, win32, amiga, sdl"

find . -name "*.h" | sort | grep -v beos |grep -v mui | \
    grep -v win32 | grep -v packets_lsend | \
    grep -v config.mac.h | grep -v amiga | \
    grep -v sdl | grep -v Freeciv.h | grep -v common/spec | \
    grep -v intl/ | grep -v common/packets_gen.h | 
    while read line
do
    line=`echo $line|sed "s|^\./||g"`

    echo "#include \"config.h\"" >test.c
    echo "#include \"$line\"" >>test.c
    gcc -DHAVE_CONFIG_H -Iserver -Icommon -I. -Iclient \
	-Iclient/agents -Iclient/include -Icommon/aicore \
	-I/usr/include/gtk-1.2 -I/usr/include/glib-1.2 \
	-I/usr/lib/glib/include -I/usr/X11R6/include -Iintl \
	-g -O2 -Wall -c test.c
done
rm test.c test.o
