#!/bin/sh

echo "# Report code which uses functions where better freeciv"
echo "# replacements should be used."
echo "# Excludes: amiga, gui-mui, support.c, mem.c"

find . -name "*.c" | sort | \
grep -v amiga | grep -v gui-mui | \
grep -v intl | \
grep -v SDL_ttf.c | \
grep -v support.c | grep -v mem.c | \
while read line; do
  python `dirname $0`/c_comment_striper.py <$line >${line}_

  #grep -n 'sprintf' ${line}_ /dev/null | grep -v snprintf
  grep -n 'snprintf' ${line}_ /dev/null| grep -v cat_snprintf | grep -v my_snprintf | grep -v my_vsnprintf
  grep -n 'strcasecmp' ${line}_ /dev/null | grep -v mystrcasecmp
  grep -n 'strncasecmp' ${line}_ /dev/null | grep -v mystrncasecmp
  grep -n 'usleep' ${line}_ /dev/null | grep -v myusleep|grep -v usleep_since_timer_start
  grep -n 'strerror' ${line}_ /dev/null | grep -v mystrerror | grep -v fz_strerror|grep -v snd_strerror
  grep -n 'gethostname' ${line}_ /dev/null | grep -v my_gethostname
  grep -n 'malloc' ${line}_ /dev/null | grep -v fc_malloc|grep -v real_malloc|grep -v sbuf_malloc
  grep -n 'calloc' ${line}_ /dev/null | grep -v fc_calloc|grep -v real_calloc
  grep -n 'realloc' ${line}_ /dev/null | grep -v fc_realloc|grep -v real_realloc
  grep -n 'strdup' ${line}_ /dev/null | grep -v mystrdup|grep -v g_strdup_printf|grep -v g_strdup_vprintf|grep -v sbuf_strdup|grep -v minstrdup|grep -v unistrdup
  grep -n 'readsocket' ${line}_ /dev/null | grep -v my_readsocket
  grep -n 'writesocket' ${line}_ /dev/null | grep -v my_writesocket
  grep -n 'strlcpy' ${line}_ /dev/null | grep -v mystrlcpy|grep -v sz_strlcpy|grep -v name_strlcpy|grep -v g_strlcpy|grep -v loud_strlcpy
  grep -n 'strlcat' ${line}_ /dev/null | grep -v mystrlcat|grep -v sz_strlcat
  for i in isalnum isalpha isdigit isprint isspace isupper toupper tolower
  do
    grep -n $i ${line}_ /dev/null | grep -v my_$i | grep -v g_unichar_isspace
  done
  rm ${line}_
done
