
import sys, re, os

def uniq(x):
    a={}
    for i in x:
        a[i]=1
    return a.keys()

def collect():
    global curr_includes
    if curr_includes:
        groups.append(curr_includes[:])
        curr_includes=[]

def get_file2dir_mapping():
    m={}
    def f(arg, dirname, names):
        for n in names:
            if not re.search("^.*\.(h|ico|xbm)$",n): continue
            if not m.has_key(n):
                m[n]=[]
            m[n].append(os.path.normpath(dirname))

    os.path.walk(".",f,"hello")

    for k in m.keys():
        if len(m[k])>1:
            m[k]="client/gui-*"
        else:
            m[k]=m[k][0]
            
    #print m
    return m

m=get_file2dir_mapping()

general_sys_includes=[
    "assert.h", "string.h", "stdlib.h",
    "stdio.h","errno.h","limits.h","stdarg.h","signal.h",
    "dirent.h","sys/stat.h","sys/types.h","ctype.h","time.h",
    "sys/time.h","unistd.h",
    "math.h"]
                    
def classify_(include, level):
    if level==1 and include=="<config.h>": return 1
    if level==0 and include[0]=="<" and \
       include[1:-1] in general_sys_includes: return 2
    if include[0]=="<": return 3
    assert include[0]==include[-1]=='"'
    include=include[1:-1]
    #assert level==0
    assert m.has_key(include), include
    if m[include] in ["common","common/aicore"]: return 4
    if m[include] in ["client","client/include", "client/agents"]: return 5
    if m[include] in ["client/gui-*"]: return 6
    if m[include] in ["server", "server/userdb"]: return 7
    if m[include] in ["ai"]: return 8
    assert 0, m[include]+" "+include

def classify(include, level):
    #print "  cond=%d %s"%(level, include),
    result=classify_(include,level)
    #print "-> %d"%(result)
    return (include, result)

for file in sys.stdin.readlines():
    file=file[:-1]
    (head, tail)=os.path.split(file)
    groups=[]
    curr_includes=[]
    level=0
    print file
    for line in open(file).readlines():
        if re.search("ifndef FC",line):
            pass
        elif re.search("#if",line):
            level=1
        elif re.search("#endif",line):
            level=0
        elif re.search("^\w*$",line):
            collect()
        else:
            mo=re.search('#include ([<"].*[>"])', line)
            if not mo: continue
            if re.search('^"spec',mo.group(1)): continue
            
            curr_includes.append(classify(mo.group(1), level))
    collect()
    #print "  ", groups

    # 1) same type in each group
    for group in groups:
        type=group[0][1]
        for x in group:
            if x[1]!=type:
                print "  %s is in wrong group"%x[0]

    # 2) group is sorted in itself
    for is_ in groups:
        should=is_[:]
        should.sort()
        if is_!=should:
            print "  wrong order"
            for j in range(len(is_)):
                i="include "+is_[j][0]
                s="include "+should[j][0]
                if i==s:
                    x=""
                else:
                    x="<->   "
                print "    %-30s%10s%-30s"%(i,x,s)

    # 3) check include of corresponding .h file
    clean_groups=groups[:]
    if tail[-1]=="c":
        last_group=clean_groups[-1]

        assert len(last_group)>0
        if len(last_group)!=1:
            print "  last group contains more than one include"
        del clean_groups[-1]

        h=last_group[0][0][1:-1][:-2]
        c=tail[:-2]
        if c!=h:
            print "  wrong file included as last include"

    # 4) check order of groups
    types=[]
    for group in clean_groups:
        types.append(group[0][1])
        
    should=types[:]
    should.sort()
    if should!=types:
        print "  wrong order of groups"

    # 5) check that each groups is only listed once
    should=uniq(types)
    tmp=types[:]
    should.sort()
    tmp.sort()
    if tmp!=should:
        print "  duplicate groups"
        print "    is     = "+repr(tmp)
        print "    should = "+repr(should)
    continue
